﻿namespace WindowsPhoneApplication2;

interface

uses
  System,
  System.Collections.Generic,
  System.Linq,
  System.Net,
  System.Windows,
  System.Windows.Controls,
  System.Windows.Documents,
  System.Windows.Input,
  System.Windows.Media,
  System.Windows.Media.Animation,
  System.Windows.Navigation,
  System.Windows.Shapes,
  Microsoft.Phone.Controls,
  Microsoft.Phone.Shell;

type
  App = public partial class(Application)

  public
    /// <summary>
    /// Provides easy access to the root frame of the Phone Application.
    /// </summary>
    /// <returns>The root frame of the Phone Application.</returns>
    property RootFrame: PhoneApplicationFrame read private write;

    /// <summary>
    /// Constructor for the Application object.
    /// </summary>
    constructor ;

  private
    // Code to execute when the application is launching (eg, from Start)
    // This code will not execute when the application is reactivated
    method Application_Launching(sender: System.Object; e: LaunchingEventArgs);

    // Code to execute when the application is activated (brought to foreground)
    // This code will not execute when the application is first launched
    method Application_Activated(sender: System.Object; e: ActivatedEventArgs);

    // Code to execute when the application is deactivated (sent to background)
    // This code will not execute when the application is closing
    method Application_Deactivated(sender: System.Object; e: DeactivatedEventArgs);

    // Code to execute when the application is closing (eg, user hit Back)
    // This code will not execute when the application is deactivated
    method Application_Closing(sender: System.Object; e: ClosingEventArgs);

    // Code to execute if a navigation fails
    method RootFrame_NavigationFailed(sender: System.Object; e: NavigationFailedEventArgs);

    // Code to execute on Unhandled Exceptions
    method Application_UnhandledException(sender: System.Object; e: ApplicationUnhandledExceptionEventArgs);

{$region Phone application initialization}

    // Avoid double-initialization
    var phoneApplicationInitialized: System.Boolean := false;

    // Do not add any additional code to this method
    method InitializePhoneApplication;

    // Do not add any additional code to this method
    method CompleteInitializePhoneApplication(sender: System.Object; e: NavigationEventArgs);
  end;
{$endregion}

implementation

constructor App;
begin
  // Global handler for uncaught exceptions. 
  UnhandledException += Application_UnhandledException;

  // Show graphics profiling information while debugging.
  if System.Diagnostics.Debugger.IsAttached then begin
    // Display the current frame rate counters.
    Application.Current.Host.Settings.EnableFrameRateCounter := true

    // Show the areas of the app that are being redrawn in each frame.
    //Application.Current.Host.Settings.EnableRedrawRegions := true;

    // Enable non-production analysis visualization mode, 
    // which shows areas of a page that are being GPU accelerated with a colored overlay.
    //Application.Current.Host.Settings.EnableCacheVisualization := true;
  end;

  // Standard Silverlight initialization
  InitializeComponent();

  // Phone-specific initialization
  InitializePhoneApplication()

end;

method App.Application_Launching(sender: System.Object; e: LaunchingEventArgs);
begin
end;

method App.Application_Activated(sender: System.Object; e: ActivatedEventArgs);
begin
end;

method App.Application_Deactivated(sender: System.Object; e: DeactivatedEventArgs);
begin
end;

method App.Application_Closing(sender: System.Object; e: ClosingEventArgs);
begin
end;

method App.RootFrame_NavigationFailed(sender: System.Object; e: NavigationFailedEventArgs);
begin
  if System.Diagnostics.Debugger.IsAttached then begin
    // A navigation has failed; break into the debugger
    System.Diagnostics.Debugger.Break()
  end
end;

method App.Application_UnhandledException(sender: System.Object; e: ApplicationUnhandledExceptionEventArgs);
begin
  if System.Diagnostics.Debugger.IsAttached then begin
    // An unhandled exception has occurred; break into the debugger
    System.Diagnostics.Debugger.Break()
  end
end;

method App.InitializePhoneApplication;
begin
  if phoneApplicationInitialized then
      exit;

  // Create the frame but don't set it as RootVisual yet; this allows the splash
  // screen to remain active until the application is ready to render.
  RootFrame := new PhoneApplicationFrame();
  RootFrame.Navigated += CompleteInitializePhoneApplication;

  // Handle navigation failures
  RootFrame.NavigationFailed += RootFrame_NavigationFailed;

  // Ensure we don't initialize again
  phoneApplicationInitialized := true
end;

method App.CompleteInitializePhoneApplication(sender: System.Object; e: NavigationEventArgs);
begin
  // Set the root visual to allow the application to render
  if RootVisual <> RootFrame then    
      RootVisual := RootFrame;

  // Remove this handler since it is no longer needed
  RootFrame.Navigated -= CompleteInitializePhoneApplication
end;

end.
