﻿namespace WindowsPhoneApplication2;

interface

uses
  System,
  System.Collections.Generic,
  System.Linq,
  System.Net,
  System.Windows,
  System.Windows.Controls,
  System.Windows.Documents,
  System.Windows.Input,
  System.Windows.Media,
  System.Windows.Media.Animation,
  System.Windows.Shapes,
  Microsoft.Phone.Controls,
  System.ServiceModel.Syndication,
  System.Collections.ObjectModel,
  System.Xml,
  System.IO,
  System.Windows.Media.Imaging;

type
  MainPage = public partial class(PhoneApplicationPage)
  private
      method Button_Click(sender: System.Object; e: System.Windows.RoutedEventArgs);
      method SearchStringCompleted(sender : Object; e : DownloadStringCompletedEventArgs);
  public
    // Constructor
    constructor ;
  end;
  
implementation

constructor MainPage;
begin
  InitializeComponent()

end;

const twitterSearchBaseUrl : String = "http://search.twitter.com/search.rss?q={0}&rpp=50";

method MainPage.Button_Click(sender: System.Object; e: System.Windows.RoutedEventArgs);
var
    searchQuery: String;
    searchQueryUri: Uri;
    searchTwitter: WebClient;
begin
    // Verifica se a caixa de texto de pesquisa foi preenchida
    if (String.IsNullOrEmpty(txtSearch.Text)) then 
      exit;

    // Formata a URL de pesquisa com o termo a pesquisar
    searchQuery := String.Format(twitterSearchBaseUrl, Uri.EscapeDataString(txtSearch.Text));
    searchQueryUri := new Uri(searchQuery, UriKind.Absolute);
    // Cria um WebClient para acesso à Web
    searchTwitter := new WebClient();
    // Quando a pesquisa retornar, executa o método SearchStringCompleted
    searchTwitter.DownloadStringCompleted += @SearchStringCompleted;
    // Inicia a consulta
    searchTwitter.DownloadStringAsync(searchQueryUri);
end;

method MainPage.SearchStringCompleted(sender : Object; e : DownloadStringCompletedEventArgs);
var
    results: System.String;
    stringReader : StringReader;
    reader : XmlReader;
    feed : SyndicationFeed;
    tweets : List<Tweet>;
begin
    // Se houve erro no download, não fazer nada
    if nil <> e.Error then 
        exit;
    tweets := new List<Tweet>();
    results := e.Result;
    // Transforma o string de resultados em um Stream
    stringReader := new StringReader(results);
    // Cria um leitor de XML
    reader := XmlReader.&Create(stringReader);
    // Usa a classe de leitura de RSS para fazer o parsing do XML
    feed := SyndicationFeed.Load(reader);
    for each item in feed.Items do begin
        var uriString := item.ElementExtensions.First(element -> element.OuterName = 'image_link').GetObject<String>();
        // Para cada feed de RSS, cria um elemento da classe Tweet
        var tweet := new Tweet(
            Nome := item.Authors[0].Email, 
            Mensagem := item.Title.Text, 
            Imagem := new BitmapImage(new Uri(uriString))
          );
      tweets.Add(tweet);
    end;
    // Configura os itens da lista para os Tweets
    lbxResults.ItemsSource := tweets;
end;

end.
